# Composition data

### What is this endpoint for?

This endpoint retrieves the historical compositions of our crypto Reference Rates, determined by our periodic rate rebalances. You can learn more about our Reference Rates [here](https://www.kaiko.com/indices/reference-rates).

### Endpoint

```
https://us.market-api.kaiko.io/v2/data/index.v1/digital_asset_rates_compo
```

### Request parameters

<table><thead><tr><th width="170">Parameter</th><th width="131">Required</th><th width="356">Description</th><th>Example</th></tr></thead><tbody><tr><td><code>index_code</code></td><td>Yes</td><td>The desired rate <a data-footnote-ref href="#user-content-fn-1"><code>ticker</code></a></td><td><code>KK_BRR_BTCUSD</code></td></tr><tr><td><code>start_time</code></td><td>No</td><td>Starting time in ISO 8601 (inclusive).</td><td><code>2023-01-25T00:00:00.000Z</code></td></tr><tr><td><code>end_time</code></td><td>No</td><td>Ending time in ISO 8601 (exclusive).</td><td><code>2023-04-25T00:00:00.000Z</code></td></tr></tbody></table>

### Response Fields

| Field               | Description                                       |
| ------------------- | ------------------------------------------------- |
| `index_code`        | The ticker of the rate                            |
| `start_period`      | Start of the composition period                   |
| `end_period`        | End of the composition period                     |
| `exchanges`         | Exchanges used during the composition period \*\* |
| `window_seconds`    | Calculation window in seconds for the period      |
| `partition_seconds` | Partition size in seconds for the period          |
| `result`            | Status of the query                               |

{% hint style="info" %}
\*\* \
\
These are the exchanges that constitute the eligible universe of trading venues for the queried rate and time.

For each publication of a rate, the methodology will use trade data from these source exchanges based on actual trading activity.

Being listed as a source exchange does not guarantee that trades from exchange will be included in any given rate calculation. For the specific exchanges used for each publication, use the [replication data endpoint](/kaiko-indices/reference-rates/replication-data.md).
{% endhint %}

### Request example

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```url
curl -H "X-Api-Key: $KAIKO_API_KEY" \
     -H 'Accept: application/json' \
    "https://us.market-api.kaiko.io/v2/data/index.v1/digital_asset_rates_compo?index_code=KK_BRR_BTCUSD&start_time=2025-06-01T00:00:00Z"
```

{% endcode %}
{% endtab %}
{% endtabs %}

### Response example

{% tabs %}
{% tab title="JSON" %}
{% code fullWidth="false" %}

```json
{
  "query": {
    "data_version": "v1",
    "request_time": "2025-09-22T12:39:25.097Z",
    "start_time": "2025-02-01T00:00:00Z",
    "end_time": "2025-04-01T00:00:00Z"
  },
  "time": "2025-09-22T12:39:25.107Z",
  "timestamp": 1758544765107,
  "data": [
    {
      "index_code": "KK_BRR_BTCUSD",
      "start_period": "2025-03-24T21:04:22.523Z",
      "end_period": "2025-06-23T21:06:13.244716Z",
      "exchanges": [
        "cbse",
        "gmni",
        "krkn",
        "lmax",
        "stmp"
      ],
      "window_seconds": 15,
      "partition_seconds": 3
    },
    {
      "index_code": "KK_BRR_BTCUSD",
      "start_period": "2025-01-07T22:00:58.271494Z",
      "end_period": "2025-03-24T21:29:22.526544Z",
      "exchanges": [
        "cbse",
        "gmni",
        "krkn",
        "lmax",
        "stmp"
      ],
      "window_seconds": 15,
      "partition_seconds": 3
    },
    {
      "index_code": "KK_BRR_ETHUSD",
      "start_period": "2025-03-24T21:04:22.523Z",
      "end_period": "2025-06-23T21:06:13.244716Z",
      "exchanges": [
        "cbse",
        "crco",
        "krkn",
        "lmax",
        "stmp"
      ],
      "window_seconds": 15,
      "partition_seconds": 3
    },
    {
      "index_code": "KK_BRR_ETHUSD",
      "start_period": "2025-01-07T22:00:58.271494Z",
      "end_period": "2025-03-24T21:29:22.526544Z",
      "exchanges": [
        "cbse",
        "crco",
        "krkn",
        "lmax",
        "stmp"
      ],
      "window_seconds": 15,
      "partition_seconds": 3
    }
  ],
  "result": "success"
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

[^1]: You can get a full list of our tickers using the [reference data endpoint](/kaiko-indices/reference-rates/reference-data.md).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kaiko.com/kaiko-indices/reference-rates/composition-data.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
